// MainDlg.cpp : implementation of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "MainDlg.h"
#include "passdlg.h"
#include "showbuffdlg.h"

void ShowShellExecuteErr( CString sFileName, DWORD dErr );

LRESULT CMainDlg::OnInitDialog( UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/ )
{
    // center the dialog on the screen
    CenterWindow();

    // set icons
    HICON hIcon = ( HICON ) ::LoadImage( _Module.GetResourceInstance(), MAKEINTRESOURCE( IDR_MAINFRAME ),
                                         IMAGE_ICON, ::GetSystemMetrics( SM_CXICON ), ::GetSystemMetrics( SM_CYICON ), LR_DEFAULTCOLOR );
    SetIcon( hIcon, TRUE );
    HICON hIconSmall = ( HICON ) ::LoadImage( _Module.GetResourceInstance(), MAKEINTRESOURCE( IDR_MAINFRAME ),
                                              IMAGE_ICON, ::GetSystemMetrics( SM_CXSMICON ), ::GetSystemMetrics( SM_CYSMICON ), LR_DEFAULTCOLOR );
    SetIcon( hIconSmall, FALSE );

    //   
    TCHAR FullName[ MAX_PATH ]; //    
    ::GetModuleFileName( NULL, FullName, MAX_PATH );

    //  
    TCHAR drive[ _MAX_DRIVE ], dir[ _MAX_DIR ],
    fname[ _MAX_FNAME ], ext[ _MAX_EXT ];
    //   
    _splitpath( FullName, drive, dir, fname, ext );
    //   
    m_sExePath = drive;
    m_sExePath += dir;

    //   exe  
    //       
    ::SetCurrentDirectory( m_sExePath.c_str() );

    m_iInData = 0;
    VisibleInData( m_iInData );
    m_iKeyData = 0;
    VisibleKeyData( m_iKeyData );
    m_iOutData = 0;
    VisibleOutData( m_iOutData );
    m_sInFileName = "..\\test\\infile.txt";
    m_sOutFileName = "..\\test\\outfile.sig";
    m_sSecKeyFileName = "..\\test\\sectest.asc";
    m_sInData = "       ,    ,    \r\n"
                "           .  \r\n"
                "          ,   \r\n"
                "     143%,     4.7.2\r\n"
                "     , \" \".\r\n";
    m_sSignerID = "test@pgp.com";
    m_bDlgFromSDK = TRUE;
    m_bDetachOut = TRUE;
    m_bASCIIOutput = TRUE;
    m_bASCIIInput = TRUE;
    m_bClearSig = FALSE;

    m_AlgoCombo = GetDlgItem( IDC_COMBO_ALGO );
    m_AlgoCombo.InsertString( 0, "IDEA" );
    m_AlgoCombo.InsertString( 1, "3DES" );
    m_AlgoCombo.InsertString( 2, "CAST5" );
    m_iAlgoType = 0;
    m_AlgoCombo.SetCurSel( m_iAlgoType );

    m_HashCombo = GetDlgItem( IDC_COMBO_HASH );
    m_HashCombo.InsertString( 0, "MD5" );
    m_HashCombo.InsertString( 1, "SHA" );
    m_HashCombo.InsertString( 2, "RIPEMD160" );
    m_iHashType = 0;
    m_HashCombo.SetCurSel( m_iHashType );

    //  PGP
    if ( !m_pgp.Init() )
        ::MessageBox( m_hWnd, m_pgp.GetErrDesc().c_str(), m_pgp.GetErrPlace().c_str(), MB_OK | MB_ICONSTOP );

    //  m_pgp     
    if ( !m_pgp.SetASCIIoutput( m_bASCIIOutput ) ||
         !m_pgp.SetASCIIinput( m_bASCIIInput ) ||
         !m_pgp.SetDetachedSig( m_bDetachOut ) ||
         !m_pgp.SetClearSigning( m_bClearSig ) ||
         !m_pgp.SetCipherAlgorithm( ( PGPCipherAlgorithm ) ( m_iAlgoType + 1 ) ) ||
         !m_pgp.SetHashAlgorithm( ( PGPHashAlgorithm ) ( m_iHashType + 1 ) ) )
        ::MessageBox( m_hWnd, m_pgp.GetErrDesc().c_str(), m_pgp.GetErrPlace().c_str(), MB_OK | MB_ICONSTOP );

    m_CheckInp = GetDlgItem( IDC_CHECK_ASCII_INP );
    m_CheckInp.EnableWindow( !m_bClearSig );

    m_CheckOut = GetDlgItem( IDC_CHECK_ASCII_OUT );
    m_CheckOut.EnableWindow( !m_bClearSig );

    m_CheckDetachOut = GetDlgItem( IDC_CHECK_DETACH_OUT );
    m_CheckDetachOut.EnableWindow( !m_bClearSig );

    DoDataExchange( FALSE );

    return TRUE;
}

LRESULT CMainDlg::OnAppAbout( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    CSimpleDialog<IDD_ABOUTBOX, FALSE> dlg;
    dlg.DoModal();
    return 0;
}

LRESULT CMainDlg::OnOK( WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    //      ENTER
    //EndDialog(wID);
    return 0;
}

LRESULT CMainDlg::OnCancel( WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    EndDialog( wID );
    return 0;
}

void CMainDlg::VisibleInData( int iInData )
{
    switch ( iInData )
    {

        case 0:
            GetDlgItem( IDC_BUTTON_INFILE_FIND ).EnableWindow( TRUE );
            GetDlgItem( IDC_EDIT_IN_FILE ).EnableWindow( TRUE );
            GetDlgItem( IDC_BUTTON_INFILE_SHOW ).EnableWindow( TRUE );
            GetDlgItem( IDC_EDIT_INDATA ).EnableWindow( FALSE );
            break;

        case 1:
            GetDlgItem( IDC_BUTTON_INFILE_FIND ).EnableWindow( FALSE );
            GetDlgItem( IDC_EDIT_IN_FILE ).EnableWindow( FALSE );
            GetDlgItem( IDC_BUTTON_INFILE_SHOW ).EnableWindow( FALSE );
            GetDlgItem( IDC_EDIT_INDATA ).EnableWindow( TRUE );
            break;

        default:
            break;
    }

}

void CMainDlg::VisibleKeyData( int ikeyData )
{
    switch ( ikeyData )
    {

        case 0:
            GetDlgItem( IDC_BUTTON_SECKEY_FIND ).EnableWindow( TRUE );
            GetDlgItem( IDC_EDIT_SECKEY_FILE ).EnableWindow( TRUE );
            break;

        case 1:
            GetDlgItem( IDC_BUTTON_SECKEY_FIND ).EnableWindow( FALSE );
            GetDlgItem( IDC_EDIT_SECKEY_FILE ).EnableWindow( FALSE );
            break;

        default:
            break;
    }

}

void CMainDlg::VisibleOutData( int ioutData )
{
    switch ( ioutData )
    {

        case 0:
            GetDlgItem( IDC_EDIT_OUT_FILE ).EnableWindow( TRUE );
            GetDlgItem( IDC_BUTTON_OUTFILE_FIND ).EnableWindow( TRUE );
            GetDlgItem( IDC_BUTTON_OUTFILE_SHOW ).EnableWindow( TRUE );
            break;

        case 1:
            GetDlgItem( IDC_EDIT_OUT_FILE ).EnableWindow( FALSE );
            GetDlgItem( IDC_BUTTON_OUTFILE_FIND ).EnableWindow( FALSE );
            GetDlgItem( IDC_BUTTON_OUTFILE_SHOW ).EnableWindow( FALSE );
            break;

        default:
            break;
    }
}

LRESULT CMainDlg::OnBnClickedRadioIndata( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        VisibleInData( m_iInData );
    }

    return 0;
}

LRESULT CMainDlg::OnBnClickedRadio2( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        VisibleInData( m_iInData );
    }

    return 0;
}

LRESULT CMainDlg::OnBnClickedRadioKeydata( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        VisibleKeyData( m_iKeyData );
    }

    return 0;
}

LRESULT CMainDlg::OnBnClickedRadio4( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        VisibleKeyData( m_iKeyData );
    }

    return 0;
}

LRESULT CMainDlg::OnBnClickedRadio3( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        VisibleOutData( m_iOutData );
    }

    return 0;
}


LRESULT CMainDlg::OnBnClickedRadioOutdata( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        VisibleOutData( m_iOutData );
    }

    return 0;
}

LRESULT CMainDlg::OnBnClickedButtonInfileFind( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        CFileDialog fd( TRUE, "txt", m_sInFileName, OFN_HIDEREADONLY /*| OFN_FILEMUSTEXIST*/,
                        "All Files ( *.* ) \0 * .*\0\0", m_hWnd );

        if ( fd.DoModal() == IDOK )
        {
            m_sInFileName = fd.m_szFileName;
            DoDataExchange( FALSE );
        }

    }

    //   exe  
    //       
    ::SetCurrentDirectory( m_sExePath.c_str() );

    return 0;
}

LRESULT CMainDlg::OnBnClickedButtonSeckeyFind( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        CFileDialog fd( TRUE, "asc", m_sSecKeyFileName, OFN_HIDEREADONLY /*| OFN_FILEMUSTEXIST*/,
                        "ASC Files ( *.asc ) \0 * .asc\0All Files ( *.* ) \0 * .*\0\0", m_hWnd );

        if ( fd.DoModal() == IDOK )
        {
            m_sSecKeyFileName = fd.m_szFileName;
            DoDataExchange( FALSE );
        }
    }

    //   exe  
    //       
    ::SetCurrentDirectory( m_sExePath.c_str() );

    return 0;
}

LRESULT CMainDlg::OnBnClickedButtonInfileShow( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        DWORD dErr = ( DWORD ) ::ShellExecute( NULL, "open", "notepad.exe", m_sInFileName, NULL, SW_SHOW );
        ::ShowShellExecuteErr( "notepad.exe", dErr );
    }

    return 0;
}

LRESULT CMainDlg::OnBnClickedCheckAsciiInp( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        if ( !m_pgp.SetASCIIinput( m_bASCIIInput ) )
            ::MessageBox( m_hWnd, m_pgp.GetErrDesc().c_str(), m_pgp.GetErrPlace().c_str(), MB_OK | MB_ICONSTOP );
    }

    return 0;
}

LRESULT CMainDlg::OnBnClickedCheckAsciiOut( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( DoDataExchange( TRUE ) )
    {
        if ( !m_pgp.SetASCIIoutput( m_bASCIIOutput ) )
            ::MessageBox( m_hWnd, m_pgp.GetErrDesc().c_str(), m_pgp.GetErrPlace().c_str(), MB_OK | MB_ICONSTOP );
    }

    return 0;
}

LRESULT CMainDlg::OnCbnSelchangeComboAlgo( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    m_iAlgoType = m_AlgoCombo.GetCurSel();

    if ( !m_pgp.SetCipherAlgorithm( ( PGPCipherAlgorithm ) ( m_iAlgoType + 1 ) ) )
        ::MessageBox( m_hWnd, m_pgp.GetErrDesc().c_str(), m_pgp.GetErrPlace().c_str(), MB_OK | MB_ICONSTOP );

    return 0;
}

LRESULT CMainDlg::OnCbnSelchangeComboHash(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
    m_iHashType = m_HashCombo.GetCurSel();

    if ( !m_pgp.SetHashAlgorithm( ( PGPHashAlgorithm ) ( m_iHashType + 1 ) ) )
        ::MessageBox( m_hWnd, m_pgp.GetErrDesc().c_str(), m_pgp.GetErrPlace().c_str(), MB_OK | MB_ICONSTOP );

    return 0;
}

LRESULT CMainDlg::OnBnClickedCheckDetachOut(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
    if ( DoDataExchange( TRUE ) )
    {
        if ( !m_pgp.SetDetachedSig( m_bDetachOut ) )
            ::MessageBox( m_hWnd, m_pgp.GetErrDesc().c_str(), m_pgp.GetErrPlace().c_str(), MB_OK | MB_ICONSTOP );
    }

    return 0;
}

LRESULT CMainDlg::OnBnClickedCheckClearSig(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
    if ( DoDataExchange( TRUE ) )
    {
        if ( m_bClearSig )
        {
            m_bASCIIOutput = TRUE;
            m_bASCIIInput = TRUE;
            m_bDetachOut = FALSE;
            //    
            m_CheckInp.SetCheck(m_bASCIIInput);
            m_CheckOut.SetCheck(m_bASCIIOutput);
            m_CheckDetachOut.SetCheck(m_bDetachOut);
        }

        //  ,     
        m_CheckInp.EnableWindow( !m_bClearSig );
        m_CheckOut.EnableWindow( !m_bClearSig );
        m_CheckDetachOut.EnableWindow( !m_bClearSig );

        if ( !m_pgp.SetClearSigning( m_bClearSig ) ||
             !m_pgp.SetASCIIinput( m_bASCIIInput ) ||
             !m_pgp.SetASCIIoutput( m_bASCIIOutput ) ||
             !m_pgp.SetDetachedSig( m_bDetachOut ) )
            ::MessageBox( m_hWnd, m_pgp.GetErrDesc().c_str(), m_pgp.GetErrPlace().c_str(), MB_OK | MB_ICONSTOP );
    }

    return 0;
}

LRESULT CMainDlg::OnBnClickedButtonOutfileFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
    if ( DoDataExchange( TRUE ) )
    {
        CFileDialog fd( TRUE, "sig", m_sOutFileName, OFN_HIDEREADONLY /*| OFN_FILEMUSTEXIST*/,
                        "SIG Files ( *.sig ) \0 * .sig\0All Files ( *.* ) \0 * .*\0\0", m_hWnd );

        if ( fd.DoModal() == IDOK )
        {
            m_sOutFileName = fd.m_szFileName;
            DoDataExchange( FALSE );
        }

    }

    //   exe  
    //       
    ::SetCurrentDirectory( m_sExePath.c_str() );

    return 0;
}

LRESULT CMainDlg::OnBnClickedButtonOutfileShow(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
    if ( DoDataExchange( TRUE ) )
    {
        DWORD dErr = ( DWORD ) ::ShellExecute( NULL, "open", "notepad.exe", m_sOutFileName, NULL, SW_SHOW );
        ::ShowShellExecuteErr( "notepad.exe", dErr );
    }

    return 0;
}

#define INDATA_FROM_FILE     0
#define INDATA_FROM_BUFFER   1
#define KEY_FROM_FILE        0
#define KEY_FROM_RESOURCE    1
#define OUT_TO_FILE          0
#define OUT_TO_BUFFER        1

LRESULT CMainDlg::OnBnClickedButtonSign( WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/ )
{
    if ( !DoDataExchange( TRUE ) )
        return 0;

    //   ,    
    //       
    //     
    ::DeleteFile( m_sOutFileName );

    //  
    if ( m_bDlgFromSDK )
    {
        if ( !m_pgp.AskPassphrase( m_hWnd ) )
            return 0;
    }
    else
    {
        CPassDlg pass;

        if ( pass.DoModal() == IDOK )
        {
            m_pgp.SetPassphrase( pass.m_sPassphrase );
        }
        else
        {
            return 0;
        }
    }

    BOOL res = TRUE;
    LPBYTE OUTBUFF = NULL;
    DWORD BUFFSIZE = 0;
    m_pgp.SetSignerIDstring( (LPCTSTR)m_sSignerID );

    switch ( m_iInData )
    {
        case INDATA_FROM_FILE:
            {
                switch ( m_iKeyData )
                {
                    case KEY_FROM_FILE:
                        {
                            switch ( m_iOutData )
                            {
                                case OUT_TO_FILE:
                                    {
                                        res = m_pgp.SignFile2File( ( LPCTSTR ) m_sInFileName,
                                                                   ( LPCTSTR ) m_sOutFileName,
                                                                   ( LPCTSTR ) m_sSecKeyFileName );
                                    }
                                    break;

                                case OUT_TO_BUFFER:
                                    {
                                        res = m_pgp.SignFile2Buff( ( LPCTSTR ) m_sInFileName,
                                                                   OUTBUFF,
                                                                   BUFFSIZE,
                                                                   ( LPCTSTR ) m_sSecKeyFileName );
                                    }
                                    break;

                                default:
                                    break;
                            }
                        }
                        break;

                    case KEY_FROM_RESOURCE:
                        {
                            switch ( m_iOutData )
                            {
                                case OUT_TO_FILE:
                                    {
                                        res = m_pgp.SignFile2File( ( LPCTSTR ) m_sInFileName,
                                                                   ( LPCTSTR ) m_sOutFileName,
                                                                   _T( "PGPTESTSECKEY" ),
                                                                   _T( "PGPKEYS" ) );
                                    }
                                    break;

                                case OUT_TO_BUFFER:
                                    {
                                        res = m_pgp.SignFile2Buff( ( LPCTSTR ) m_sInFileName,
                                                                   OUTBUFF,
                                                                   BUFFSIZE,
                                                                   _T( "PGPTESTSECKEY" ),
                                                                   _T( "PGPKEYS" ) );
                                    }
                                    break;

                                default:
                                    break;
                            }
                        }
                        break;

                    default:
                        break;
                }
            }
            break;

        case INDATA_FROM_BUFFER:
            {
                switch ( m_iKeyData )
                {
                    case KEY_FROM_FILE:
                        {
                            switch ( m_iOutData )
                            {

                                case OUT_TO_FILE:
                                    {
                                        res = m_pgp.SignBuff2File( ( LPCVOID ) ( LPCTSTR ) m_sInData,
                                                                   ( DWORD ) m_sInData.GetLength(),
                                                                   ( LPCTSTR ) m_sOutFileName,
                                                                   ( LPCTSTR ) m_sSecKeyFileName );
                                    }
                                    break;

                                case OUT_TO_BUFFER:
                                    {
                                        res = m_pgp.SignBuff2Buff( ( LPCVOID ) ( LPCTSTR ) m_sInData,
                                                                   ( DWORD ) m_sInData.GetLength(),
                                                                   OUTBUFF,
                                                                   BUFFSIZE,
                                                                   ( LPCTSTR ) m_sSecKeyFileName );
                                    }
                                    break;

                                default:
                                    break;
                            }
                        }
                        break;

                    case KEY_FROM_RESOURCE:
                        {
                            switch ( m_iOutData )
                            {

                                case OUT_TO_FILE:
                                    {
                                        res = m_pgp.SignBuff2File( ( LPCVOID ) ( LPCTSTR ) m_sInData,
                                                                   ( DWORD ) m_sInData.GetLength(),
                                                                   ( LPCTSTR ) m_sOutFileName,
                                                                   _T( "PGPTESTSECKEY" ),
                                                                   _T( "PGPKEYS" ) );
                                    }

                                    break;

                                case OUT_TO_BUFFER:
                                    {
                                        res = m_pgp.SignBuff2Buff( ( LPCVOID ) ( LPCTSTR ) m_sInData,
                                                                   ( DWORD ) m_sInData.GetLength(),
                                                                   OUTBUFF,
                                                                   BUFFSIZE,
                                                                   _T( "PGPTESTSECKEY" ),
                                                                   _T( "PGPKEYS" ) );
                                    }
                                    break;

                                default:
                                    break;
                            }
                        }
                        break;

                    default:
                        break;
                }
            }
            break;

        default:
            break;
    }

    if ( !res )
    {
        ::MessageBox( m_hWnd, m_pgp.GetErrDesc().c_str(), m_pgp.GetErrPlace().c_str(), MB_OK | MB_ICONSTOP );
        return 0;
    }
    else
    {
        if ( OUTBUFF && BUFFSIZE )
        {
            //      ,  PGPEncode
            //     
            // ,     
            //  
            CString s = ( CString( ( char* ) OUTBUFF ) ).Left( BUFFSIZE );
            CShowBuffDlg dlg( s );
            dlg.DoModal();
        }
        else
        {
            //   ,    
            if ( CFindFile().FindFile( m_sOutFileName ) )
            {
                DWORD dErr = ( DWORD ) ::ShellExecute( NULL, "open", "notepad.exe", m_sOutFileName, NULL, SW_SHOW );
                ::ShowShellExecuteErr( "notepad.exe", dErr );
            }
            else
            {
                ::MessageBox(m_hWnd, " !     ", "", MB_OK | MB_ICONERROR );
            }
        }
        delete[] OUTBUFF;
        OUTBUFF = NULL;
    }

    return 0;
}




