// MainDlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once
#include "simplepgp.h"

class CMainDlg : public CDialogImpl<CMainDlg>
               , public CWinDataExchange<CMainDlg>
{
public:
	enum { IDD = IDD_MAINDLG };

	BEGIN_MSG_MAP(CMainDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
        COMMAND_HANDLER(IDC_RADIO_INDATA, BN_CLICKED, OnBnClickedRadioIndata)
        COMMAND_HANDLER(IDC_RADIO2, BN_CLICKED, OnBnClickedRadio2)
        COMMAND_HANDLER(IDC_RADIO_KEYDATA, BN_CLICKED, OnBnClickedRadioKeydata)
        COMMAND_HANDLER(IDC_RADIO3, BN_CLICKED, OnBnClickedRadio3)
        COMMAND_HANDLER(IDC_RADIO4, BN_CLICKED, OnBnClickedRadio4)
        COMMAND_HANDLER(IDC_RADIO_OUTDATA, BN_CLICKED, OnBnClickedRadioOutdata)
        COMMAND_HANDLER(IDC_BUTTON_INFILE_FIND, BN_CLICKED, OnBnClickedButtonInfileFind)
        COMMAND_HANDLER(IDC_BUTTON_SECKEY_FIND, BN_CLICKED, OnBnClickedButtonSeckeyFind)
        COMMAND_HANDLER(IDC_BUTTON_INFILE_SHOW, BN_CLICKED, OnBnClickedButtonInfileShow)
        COMMAND_HANDLER(IDC_BUTTON_SIGN, BN_CLICKED, OnBnClickedButtonSign)
        COMMAND_HANDLER(IDC_CHECK_ASCII_INP, BN_CLICKED, OnBnClickedCheckAsciiInp)
        COMMAND_HANDLER(IDC_CHECK_ASCII_OUT, BN_CLICKED, OnBnClickedCheckAsciiOut)
        COMMAND_HANDLER(IDC_COMBO_ALGO, CBN_SELCHANGE, OnCbnSelchangeComboAlgo)
        COMMAND_HANDLER(IDC_CHECK_DETACH_OUT, BN_CLICKED, OnBnClickedCheckDetachOut)
        COMMAND_HANDLER(IDC_BUTTON_OUTFILE_FIND, BN_CLICKED, OnBnClickedButtonOutfileFind)
        COMMAND_HANDLER(IDC_BUTTON_OUTFILE_SHOW, BN_CLICKED, OnBnClickedButtonOutfileShow)
        COMMAND_HANDLER(IDC_CHECK_CLEAR_SIG, BN_CLICKED, OnBnClickedCheckClearSig)
        COMMAND_HANDLER(IDC_COMBO_HASH, CBN_SELCHANGE, OnCbnSelchangeComboHash)
    END_MSG_MAP()

    BEGIN_DDX_MAP( CMainDlg )
        DDX_RADIO( IDC_RADIO_INDATA, m_iInData )
        DDX_RADIO( IDC_RADIO_KEYDATA, m_iKeyData )
        DDX_RADIO( IDC_RADIO_OUTDATA, m_iOutData )
        DDX_TEXT( IDC_EDIT_IN_FILE, m_sInFileName )
        DDX_TEXT( IDC_EDIT_OUT_FILE, m_sOutFileName )
        DDX_TEXT( IDC_EDIT_SECKEY_FILE, m_sSecKeyFileName )
        DDX_TEXT( IDC_EDIT_INDATA, m_sInData )
        DDX_CHECK( IDC_CHECK_PASSDLG, m_bDlgFromSDK )
        DDX_CHECK( IDC_CHECK_ASCII_OUT, m_bASCIIOutput )
        DDX_CHECK( IDC_CHECK_ASCII_INP, m_bASCIIInput )
        DDX_CHECK( IDC_CHECK_DETACH_OUT, m_bDetachOut )
        DDX_TEXT( IDC_EDIT_SIGNER_ID, m_sSignerID )
        DDX_CHECK( IDC_CHECK_CLEAR_SIG, m_bClearSig )
    END_DDX_MAP()

        // Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

protected:
    CSimplePGP m_pgp;
    //   exe-
    string m_sExePath;

    //   
    int m_iInData;
    //   
    int m_iKeyData;
    //    
    int m_iOutData;
    //   
    CString m_sInFileName;
    //   
    CString m_sOutFileName;
    //     
    CString m_sSecKeyFileName;
    //     Edit
    CString m_sInData;
    //      PGPSDK?
    BOOL m_bDlgFromSDK;
    //  
    BOOL m_bASCIIOutput;
    //   
    BOOL m_bASCIIInput;
    //    
    int m_iAlgoType;
    CComboBox m_AlgoCombo;
    //  -   
    BOOL m_bDetachOut;
    //  -  
    CButton m_CheckInp, m_CheckOut, m_CheckDetachOut;
    //    
    CString m_sSignerID;
    // "" ,  
    BOOL m_bClearSig;
    //    
    int m_iHashType;
    CComboBox m_HashCombo;

    void VisibleInData( int iInData );
    void VisibleKeyData( int ikeyData );
    void VisibleOutData( int ioutData );

public:
    LRESULT OnBnClickedRadioIndata(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedRadio2(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedRadioKeydata(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedRadio3(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedRadio4(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedRadioOutdata(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedButtonInfileFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedButtonSeckeyFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedButtonInfileShow(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedButtonSign(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedCheckAsciiInp(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedCheckAsciiOut(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnCbnSelchangeComboAlgo(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedCheckDetachOut(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedButtonOutfileFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedButtonOutfileShow(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnBnClickedCheckClearSig(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
    LRESULT OnCbnSelchangeComboHash(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
};
