#ifndef _SIMPLEPGP_H_5D07C0B9_FCAC_40A8_BB01_7536FDE1A93F
#define _SIMPLEPGP_H_5D07C0B9_FCAC_40A8_BB01_7536FDE1A93F

#define PGP_WIN32 1

#include <pgpErrors.h>
#include <pgpUtilities.h>
#include <pgpKeys.h>
#include <pgpEncode.h>
#include <string>
#include <vector>

using std::string;
using std::vector;

class CSimplePGP
{

    public:
        CSimplePGP( void );
        ~CSimplePGP( void );

    protected:
        // PGP-
        PGPContextRef m_context;
        //  ,    
        PGPOptionListRef m_optsEncode;
        //  ,    
        PGPOptionListRef m_optsPassphrase;
        //   ,    
        PGPOptionListRef m_optsSigning;
        //   
        BOOL m_bIsInit;
        //    
        BOOL ImportKeySetFromFile( LPCTSTR keyFileName, PGPKeySetRef& keySet );
        //    
        BOOL ImportKeySetFromResorce( LPCTSTR ResourceName, LPCTSTR ResourceType, PGPKeySetRef& keySet );
        //    
        string m_sWhere;
        //  
        TCHAR m_sWhat[ 256 ];
        // 
        string m_sVersion;
        // 
        string m_sComment;
        //  
        BOOL m_bASCIIoutput;
        //   
        BOOL m_bASCIIinput;
        //         
        BOOL ReBuildEncodeOptionList();
        //          
        BOOL ReBuildSigningOptionList();
        //      
        BOOL IsOutBuffNotNull( LPBYTE& OutData );
        //    
        PGPCipherAlgorithm m_algoID;
        // "" ,  ?
        BOOL m_bClearSign;
        //    ?
        BOOL m_bDetachedSig;
        //     ,    
        PGPKeyRef GetFirstKeyFromSet( PGPKeySetRef &keyset );
        //   
        string m_sSignerID;
        //     
        PGPHashAlgorithm m_hashID;

    public:
        // 
        BOOL Init();
        //    
        BOOL SetVersion ( LPCTSTR sVersion );
        //   - 
        BOOL SetComment ( LPCTSTR sComment );
        //   
        BOOL SetASCIIoutput ( BOOL bASCIIout );
        //   
        BOOL SetASCIIinput ( BOOL bASCIIinp );
        //    
        BOOL SetCipherAlgorithm( PGPCipherAlgorithm algoID );
        //     
        BOOL SetPassphrase ( LPCTSTR sPassphrase );
        //   -     ,     
        BOOL SetClearSigning ( BOOL bClearsign );
        //  -    
        BOOL SetDetachedSig ( BOOL bDetachedSig );
        //  -  -   
        void SetSignerIDstring ( string signerID );
        //  
        BOOL SetHashAlgorithm( PGPHashAlgorithm hashID );

#ifdef _WITH_PGPUI_
        //     c  PGPsdkUI.dll
        BOOL AskPassphrase( HWND hwndParent );
#endif

        //    
        string GetErrPlace()
        {
            return m_sWhere;
        }

        string GetErrDesc()
        {
            return string(m_sWhat);
        }

        // 
        //    ,     
        BOOL EncodeFile2File( LPCTSTR inFileName,      //   
                              LPCTSTR outFileName,     //   
                              LPCTSTR keyFileName );   //     

        //    ,    
        BOOL EncodeFile2File( LPCTSTR inFileName,      //   
                              LPCTSTR outFileName,     //   
                              LPCTSTR resourceName,    //   c   
                              LPCTSTR resourceType );  //  

        //    ,     
        BOOL EncodeBuff2File( const VOID* inData,      //     
                              DWORD dwDataSize,        //  
                              LPCTSTR outFileName,     //   
                              LPCTSTR keyFileName );   //     

        //    ,    
        BOOL EncodeBuff2File( const VOID* inData,      //     
                              DWORD dwDataSize,        //  
                              LPCTSTR outFileName,     //   
                              LPCTSTR resourceName,    //   c  
                              LPCTSTR resourceType );  //  

        //       
        //   OutData,     
        //  ,  
        //    
        //   BuffSize

        //    ,    .
        BOOL EncodeFile2Buff( LPCTSTR inFileName,      //   
                              LPBYTE& OutData,         //     
                              DWORD& BuffSize,         //   
                              LPCTSTR keyFileName );   //     

        //    ,    
        BOOL EncodeFile2Buff( LPCTSTR inFileName,      //   
                              LPBYTE& OutData,         //     
                              DWORD& BuffSize,         //   
                              LPCTSTR resourceName,    //   c   
                              LPCTSTR resourceType );  //  

        //    ,    
        BOOL EncodeBuff2Buff( const VOID* inData,      //     
                              DWORD dwDataSize,        //  
                              LPBYTE& OutData,         //     
                              DWORD& BuffSize,         //   
                              LPCTSTR keyFileName );   //     

        //    ,    
        BOOL EncodeBuff2Buff( const VOID* inData,      //     
                              DWORD dwDataSize,        //  
                              LPBYTE& OutData,         //     
                              DWORD& BuffSize,         //   
                              LPCTSTR resourceName,    //   c  
                              LPCTSTR resourceType );  //  

        // 
        //    ,     
        BOOL DecodeFile2File( LPCTSTR inFileName,      //   
                              LPCTSTR outFileName,     //   
                              LPCTSTR keyFileName );   //     

        //    ,    
        BOOL DecodeFile2File( LPCTSTR inFileName,      //   
                              LPCTSTR outFileName,     //   
                              LPCTSTR resourceName,    //   c   
                              LPCTSTR resourceType );  //  

        //    ,     
        BOOL DecodeBuff2File( const VOID* inData,      //     
                              DWORD dwDataSize,        //  
                              LPCTSTR outFileName,     //   
                              LPCTSTR keyFileName );   //     

        //    ,    
        BOOL DecodeBuff2File( const VOID* inData,      //     
                              DWORD dwDataSize,        //  
                              LPCTSTR outFileName,     //   
                              LPCTSTR resourceName,    //   c  
                              LPCTSTR resourceType );  //  

        //    ,    .
        BOOL DecodeFile2Buff( LPCTSTR inFileName,      //   
                              LPBYTE& OutData,         //     
                              DWORD& BuffSize,         //   
                              LPCTSTR keyFileName );   //     

        //    ,    
        BOOL DecodeFile2Buff( LPCTSTR inFileName,      //   
                              LPBYTE& OutData,         //     
                              DWORD& BuffSize,         //   
                              LPCTSTR resourceName,    //   c   
                              LPCTSTR resourceType );  //  

        //    ,    
        BOOL DecodeBuff2Buff( const VOID* inData,      //     
                              DWORD dwDataSize,        //  
                              LPBYTE& OutData,         //     
                              DWORD& BuffSize,         //   
                              LPCTSTR keyFileName );   //     

        //    ,    
        BOOL DecodeBuff2Buff( const VOID* inData,      //     
                              DWORD dwDataSize,        //  
                              LPBYTE& OutData,         //     
                              DWORD& BuffSize,         //   
                              LPCTSTR resourceName,    //   c  
                              LPCTSTR resourceType );  //  

        //  
        //  ,     
        BOOL SignFile2File( LPCTSTR inFileName,      //     
                            LPCTSTR outFileName,     //   
                            LPCTSTR keyFileName );   //     

        //  ,    
        BOOL SignFile2File( LPCTSTR inFileName,      //   
                            LPCTSTR outFileName,     //   
                            LPCTSTR resourceName,    //   c   
                            LPCTSTR resourceType );  //  

        //  -  ,  -  ,     
        BOOL SignBuff2File( const VOID* inData,      //     
                            DWORD dwDataSize,        //  
                            LPCTSTR outFileName,     //   
                            LPCTSTR keyFileName );   //     

        //  -  ,  -  ,    
        BOOL SignBuff2File( const VOID* inData,      //     
                            DWORD dwDataSize,        //  
                            LPCTSTR outFileName,     //   
                            LPCTSTR resourceName,    //   c   
                            LPCTSTR resourceType );  //  

        //  -  ,  -  ,    .
        BOOL SignFile2Buff( LPCTSTR inFileName,      //   
                            LPBYTE& OutData,         //     
                            DWORD& BuffSize,         //   
                            LPCTSTR keyFileName );   //     

        //  -  ,  -  ,    
        BOOL SignFile2Buff( LPCTSTR inFileName,      //   
                            LPBYTE& OutData,         //     
                            DWORD& BuffSize,         //   
                            LPCTSTR resourceName,    //   c   
                            LPCTSTR resourceType );  //  

        //  -  ,  -  ,    
        BOOL SignBuff2Buff( const VOID* inData,      //     
                            DWORD dwDataSize,        //  
                            LPBYTE& OutData,         //     
                            DWORD& BuffSize,         //   
                            LPCTSTR keyFileName );   //     

        //  -  ,  -  ,    
        BOOL SignBuff2Buff( const VOID* inData,      //     
                            DWORD dwDataSize,        //  
                            LPBYTE& OutData,         //     
                            DWORD& BuffSize,         //   
                            LPCTSTR resourceName,    //   c  
                            LPCTSTR resourceType );  //  
};

#endif
